/*
 * Image.java
 *
 * Created on 14 mai 2002
 */
 
/** Class Image <p>
 * This class allows a strip acquisition, i.e a strip with an acquisition 
 * direction, to be represented and handled.<br>
 * The terms 'strip acquisition' and 'image' are equivalent.
 * Company:      ONERA/DCSD/CD<p>
 * @author Matthieu Lombard mlombard@operamail.com
 * @version 0.0
 * @see Request
 * @see Strip
 */
 
import java.util.*;

public class Image {
  
//-----------------------------------------------------------------------------------
//*******************            A T T R I B U T E S            *********************
//-----------------------------------------------------------------------------------

  /** index of the image in the list of images lImage
   * @see InstanceProblem#lImage */
  protected int k;

  /** strip associated with this image*/
  protected Strip Strak;

  /** acquisition direction, 0 or 1 */
  protected int Dirak;
  
  /** earliest starting time of acquisition */
  protected double Tmink;

  /** latest starting time of acquisition*/
  protected double Tmaxk;
  
  /** GeoPoint where the acquisition begins*/
  protected  GeoPoint geoPointInput;

  /** GeoPoint where the acquisition ends*/
  protected GeoPoint geoPointOutput;
  
//-----------------------------------------------------------------------------------
//*******************         C O N S T R U C T O R S            ********************
//-----------------------------------------------------------------------------------
  //------------------------------------Image----------------------------------
  public Image ( Strip Strak, int Dirak, int k){
    
    this.Strak = Strak;
    this.geoPointInput = (Dirak == 0) ? this.Strak.geoPoint0 : this.Strak.geoPoint1;
    this.geoPointOutput = (Dirak == 0) ? this.Strak.geoPoint1 : this.Strak.geoPoint0;
    this.Tmink = Math.max(this.geoPointInput.Te, this.geoPointOutput.Te - this.Strak.DUj);
    this.Tmaxk = Math.min(this.geoPointInput.Tl, this.geoPointOutput.Tl - this.Strak.DUj);
    this.Dirak = Dirak;
    this.k = k;

  }//Image

}//Image


